Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 6.1.0   

Resolution: Fixed   

Description

The current implementation of the Activity view triggers multiple SQL queries for each journal, which can lead to performance issues.

The attached two patches mitigate the problem.

The first patch modifies the Journal#journalized method to use the preloaded Issue association if available. Currently, the journalized

method executes redundant queries to fetch the associated Issue object, even when the Issue has already been preloaded.

The second patch updates the :scope parameter of acts_as_activity_provider to preload the tracker association through the related

Issue, reducing queries against the trackers table when displaying each journal in the Activity view.

These changes reduce the number of SQL queries when displaying journals in the Activity view and can improve overall rendering

performance.

Queries when rendering activities/index.html.erb:

log-without-patches.txt (the current implimentation)

log-with-patches.txt (with the patches applied)

Associated revisions

Revision 23446 - 2025-01-18 06:36 - Go MAEDA

Optimize `journalized` method to use preloaded Issue association for better Activity view performance (#42077).

Patch by Go MAEDA (user:maeda).

Revision 23447 - 2025-01-18 06:37 - Go MAEDA

Preload tracker when retrieving journal events to improve Activity view performance (#42077).

Patch by Go MAEDA (user:maeda).

History

#1 - 2025-01-15 11:04 - Go MAEDA

- Target version changed from Candidate for next minor release to 6.1.0

Setting the target version to 6.1.0.

#2 - 2025-01-18 06:38 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patches in r23446 and r23447.

Files

log-without-patches.txt 5.43 KB 2025-01-06 Go MAEDA

log-with-patches.txt 1.8 KB 2025-01-06 Go MAEDA

0001-Optimize-journalized-method-to-use-preloaded-Issue-a.patch 948 Bytes 2025-01-06 Go MAEDA
https://www.redmine.org/attachments/33706
https://www.redmine.org/attachments/33707
https://www.redmine.org/projects/redmine/repository/svn/revisions/23446
https://www.redmine.org/projects/redmine/repository/svn/revisions/23447


0002-Preload-tracker-when-retrieving-journal-events-to-im.patch 1.03 KB 2025-01-06 Go MAEDA
